#include <errno.h>
#include <termios.h>
#include <sys/ioctl.h>
#include <sys/ipc.h>
#include <linux/msg.h>
#include <linux/kd.h>
#include "keydefs.h"
#include "wisio.h"
#define byte unsigned char
struct termios orgtio,newtio;
static int orgmode;

#define SEC SECOND_KEYS
#define CUR CURSOR_KEYS
byte keys[128]={ 0,ESC_SKEY,'1','2','3','4','5','6',
                '7','8','9','0','-','+',BS_SKEY,TAB_SKEY,
                'Q','W','E','R','T','Y','U','I',
                'O','P','[',']',ENTER_SKEY,CTRL_SKEY,'A','S',
                'D','F','G','H','J','K','L',';',
                '*','\'',SHIFT_SKEY,'\\','Z','X','C','V',
                'B','N','M',',','.','/',SHIFT_SKEY+SEC,'*'+SEC,
                ALT_SKEY,' ',CAPS_LOCK,'a','b','c','d','e',
                'f','g','h','i','j',NUM_LOCK,SCR_LOCK,'7'+SEC,
                '8'+SEC,'9'+SEC,'-'+SEC,'4'+SEC,'5'+SEC,'6'+SEC,'+'+SEC,'1'+SEC,
                '2'+SEC,'3'+SEC,'0'+SEC,'.'+SEC,0,0,'(','k',
                'l',0,0,0,0,0,0,0,
                ENTER_SKEY+SEC,CTRL_SKEY+SEC,'/'+SEC,PRINT_SKEY,ALT_GR,0,'7'+CUR,
                '8'+CUR,'9'+CUR,'4'+CUR,'6'+CUR,'1'+CUR,'2'+CUR,'3'+CUR,'0'+CUR,
                '.'+CUR,0,0,0,0,0,0,0,
                PAUSE_SKEY,0,0,0,123,124,125,126,127
                };
int mainque;    
int flags;      
int softkey(int scans)
{
    int keycode,cflag,sflag;

    cflag=sflag=0;
    keycode = keys[scans&0x7F];
    if ((keycode & 0x7F) <= SCR_LOCK)
    {
       switch(keycode & 0x7f)
       {
	  case SHIFT_SKEY:
	     sflag = SHIFT_KFL;
	     break;
	  case CTRL_SKEY:
	     sflag = CTRL_KFL;
	     break;
	  case ALT_SKEY:
	     sflag = ALT_KFL;
	     break;
	  case ALT_GR:
	     sflag = ALTG_KFL;
	     break;
	  case CAPS_LOCK:
	  case NUM_LOCK:
	  case SCR_LOCK:
             break;
       }
    }
    if (scans & 0x80)
    {
       cflag=PRESS_KFL|sflag;
       sflag=0;
    }
    else
       sflag |=PRESS_KFL;
    flags&=~cflag;
    flags|=sflag;
    return keycode;
}

int asccode(int key)
{
    int code;
    code = softkey(key);
    if (flags&(ALT_KFL+ALTG_KFL))
       return(code <<8);
    if (code & SEC)
       flags |= SEC_KFL;
    else
       flags &= ~SEC_KFL; 
    code &= 0x7f;
    switch(code & 0x60)
    case  0x40:            /*ALPHA */
    {
       flags |= ASC_KFL;
       if(flags & CTRL_KFL)
          return(code &0x1F);
       code ^= 0x20;
       if(flags & SHIFT_KFL)
          code ^= 0x20;
       if(flags & CAPS_KFL)
          code ^= 0x20;
       return code;
    case 0x20:                                 /*NUMERIC */
       if(flags & CTRL_KFL)
          return(code <<8);
       if(flags & SHIFT_KFL)  
          code ^= 0x10;
       flags |= ASC_KFL;
       return code;
    case 0x00:                                 /* CONTROL + SHIFTS */
       if (code & 0x18)
       {
          flags |= ASC_KFL;
          return code;
       }
       flags |= CTL_KFL;
       return (code)<<8;
    case 0x60:
       if (flags & SEC_KFL)
       {
          if (code == ('0' + CURSOR_KEYS & 0x7F) && !(flags & PRESS_KFL))
             flags ^= INS_KFL;
          flags |= CUR_KFL;
          return (code&0x3F) <<8;
       }
       flags |= FUN_KFL;
       return (code&0x7F)<<8;
    } 
}

main()
{
   int keycode,asc,readed,i,res;
   msg_win_cmd mes;
   struct msginfo mi;
   int cnt=0;
   int halt;

   byte input[65];
   if (ioctl(0,KDGKBMODE, &orgmode))
   {
      printf("Cannot initialize keyboard!");
      return 1;
   }
   tcgetattr(0,&orgtio);
   newtio = orgtio;
   newtio.c_lflag &= ~(ECHO+ICANON+ISIG);
   newtio.c_iflag &= ~(ISTRIP+IGNCR+ICRNL+INLCR+IXOFF+IXON+IGNBRK);
   newtio.c_cc[VMIN]=0;
   newtio.c_cc[VTIME]=1;
   tcsetattr(0,TCSAFLUSH,&newtio);
   ioctl(0,KDSKBMODE, K_MEDIUMRAW); 
   mainque=msgget(WIN_QUE,0666|IPC_CREAT);
   mes.des = 1;
   mes.pid = 0;
   mes.cmd = CMD_ADDKEY;
   mes.cid = getpid();
   mes.flg = 0xf000;
   mes.x   = 1234;
   sleep(4);
   msgsnd(mainque,&mes,STRUCTSIZE(mes,x),0);
   flags = 0;
   res =0;
   halt =0;
   cnt=0;
   while (!halt )
   {
      readed=read(0,input,sizeof(input)-1);
      if (readed==0)
      {
         mes.des = MAINQUE;
         mes.pid = 0;
         mes.cmd = 0;
/*         mes.idx = keycode;
         mes.flg = flags;
         mes.x   = cnt++;*/
         res = msgsnd(mainque,&mes,STRUCTSIZE(mes,cmd),IPC_NOWAIT);
         if (res==-1)
            if (errno==EINVAL)
               halt = 1;
      }
      input[readed]=0;
      for (i=0; i<readed;i++)
      {
         keycode=asccode(input[i]);
         halt |= keycode == PAUSE_SKEY << 8 && flags & ALTG_KFL;
/*         printf("%d,%d\n",keycode == PAUSE_SKEY << 8, flags & ALTG_KFL);*/
/*         if (keycode)
            printf("%d::'%c'=%x %x\n",input[i],keycode&0x7f,keycode,flags);
         else
            return;*/
         mes.des = MAINQUE;
         mes.pid = 0;
         mes.cmd = CMD_ADDKEY;
         mes.idx = keycode;
         mes.flg = flags;
         mes.x   = cnt++;
         res = msgsnd(mainque,&mes,STRUCTSIZE(mes,x),IPC_NOWAIT);
         if (res==-1)
            if (errno==EINVAL)
               halt = 1;
//            else
//                  printf("%x:%x %d\n",keycode,flags,
//       res =msgctl(mainque,IPC_INFO,&mi);
//       printf("%d:%d,%d,%d,%d\n",res,mi.msgseg,mi.msgmni,mi.msgssz,mi.msgtql);
       //         res = msgsnd(mainque,&mes,STRUCTSIZE(mes,flg),IPC_NOWAIT);
      }
   }
   tcsetattr(0,TCSANOW,&orgtio);
   ioctl(0,KDSKBMODE, orgmode);
}

